!*****************************************************************************
!                                                                            *
!  FGFW2.F90                                                                 *
!                                                                            *
!  Demonstrate color selection, underlining, and kerning with fgf_print().   *
!                                                                            *
!*****************************************************************************

integer*4 function WinMain (hInstance, hPrevInstance, lpszCmdParam, nCmdShow)
!MS$ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
use msfwina
use fgwin
use fgfwin

interface
integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
integer*4 window, message, wParam, lParam
end function WindowProc
end interface

integer*4 hInstance, hPrevInstance, lpszCmdParam, nCmdShow

character*12      AppName
integer*4         iret
integer*4         window
type (T_MSG)      msg
type (T_WNDCLASS) wndclass

data AppName /'FGFW2'C/

if (hPrevInstance == 0) then
   wndclass%style         = CS_HREDRAW .or. CS_VREDRAW .or. CS_OWNDC
   wndclass%lpfnWndProc   = LOC(WindowProc)
   wndclass%cbClsExtra    = 0
   wndclass%cbWndExtra    = 0
   wndclass%hInstance     = hInstance
   wndclass%hIcon         = LoadIcon(NULL,IDI_APPLICATION)
   wndclass%hCursor       = LoadCursor(NULL,IDC_ARROW)
   wndclass%hbrBackground = NULL
   wndclass%lpszMenuName  = NULL
   wndclass%lpszClassName = LOC(AppName)
   iret = RegisterClass(wndclass)
   lpszCmdParam = lpszCmdParam
end if

window = CreateWindow(    &
   AppName,               &  ! window class name
   'Example FGFW2'C,      &  ! window caption
   WS_OVERLAPPEDWINDOW,   &  ! window style
   CW_USEDEFAULT,         &  ! initial x position
   CW_USEDEFAULT,         &  ! initial y position
   CW_USEDEFAULT,         &  ! initial x size
   CW_USEDEFAULT,         &  ! initial y size
   NULL,                  &  ! parent window handle
   NULL,                  &  ! window menu handle
   hInstance,             &  ! program instance handle
   NULL)                     ! creation parameters

iret = ShowWindow(window,nCmdShow)
iret = UpdateWindow(window)

do while (GetMessage(msg,NULL,0,0))
   iret = TranslateMessage(msg)
   iret = DispatchMessage(msg)
end do

WinMain = msg%wParam
return
end

!*****************************************************************************
!                                                                            *
!  WindowProc                                                                *
!                                                                            *
!  Window procedure to handle messages sent to the window.                   *
!                                                                            *
!*****************************************************************************

integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
use msfwina
use fgwin
use fgfwin
integer*4 window, message, wParam, lParam

type (T_PAINTSTRUCT) ps
integer*4 cxClient, cyClient
integer*4 hdc, hpal, hvb
integer*4 iret

save cxClient, cyClient, hdc, hpal, hvb

WindowProc = 0

select case (message)
   case (WM_CREATE)
      hdc = GetDC(window)
      call fg_setdc(hdc)
      hpal = fg_defpal()
      call fg_realize(hpal)

      call fg_vbinit
      hvb = fg_vballoc(640,480)
      iret = fg_vbopen(hvb)
      call fg_vbcolors

      if (fgf_load('AUSTIN36.FGF'C) == 0) then
         iret = MessageBox(window,'Unable to load font file.'C,'Error'C, &
                           MB_ICONSTOP.or.MB_OK)
         iret = DestroyWindow(window)
         return
      end if

      call fg_setcolor(255)
      call fg_fillpage

      ! display two colors in the same string
      call fg_setcolor(19)
      call fg_move(20,40)
      call fgf_print('color 19'//char(127)//char(20)//' color 20'C,19)

      ! show current color is the last color used
      call fg_move(20,80)
      call fgf_print('still color 20'C,14)

      ! display underlined characters
      call fg_setcolor(22)
      call fg_move(20,120)
      call fgf_kerning(1)
      call fgf_print('one '//char(127)//'_word'//char(127)//'_ is underlined'C,26)
      return

   case (WM_PAINT)
      iret = BeginPaint(window,ps)
      call fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1)
      iret = EndPaint(window,ps)
      return

   case (WM_SETFOCUS)
      call fg_realize(hpal)
      iret = InvalidateRect(window,NULL_RECT,.TRUE.)
      return

   case (WM_SIZE)
      cxClient = LOWORD(lParam)
      cyClient = HIWORD(lParam)
      return

   case (WM_DESTROY)
      call fgf_unload(-1)
      call fg_vbclose
      call fg_vbfree(hvb)
      call fg_vbfin
      iret = DeleteObject(hpal)
      iret = ReleaseDC(window,hdc)
      call PostQuitMessage(0)
      return
end select

WindowProc = DefWindowProc(window,message,wParam,lParam)
return
end
