/****************************************************************************\
*                                                                            *
*  FGFW3.CPP                                                                 *
*  FGFW3U.CPP                                                                *
*                                                                            *
*  Demonstrate how to display strings from two different fonts.              *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "FGFW3U.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(640,480);
   fg_vbopen(hvb);
   fg_vbcolors();

   hAustin = fgf_load("AUSTIN36.FGF");
   hModern = fgf_load("MODERN28.FGF");
   if (hAustin == 0 || hModern == 0)
   {
      Application->MessageBox("Unable to load font file.","Error",MB_ICONSTOP|MB_OK);
      Application->Terminate();
      return;
   }

   fg_setcolor(255);
   fg_fillpage();

   // display characters from the Modern font in upper left corner
   fg_setcolor(19);
   fgf_select(hModern);
   fgf_justify(-1,1);
   fgf_print("Modern 28",9);

   // display characters from the Austin font in upper right corner
   fgf_select(hAustin);
   fgf_justify(1,1);
   fg_move(fg_getmaxx(),0);
   fgf_print("Austin 36",9);

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fgf_unload(-1);
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
